searchData={"items":[{"type":"module","title":"ExtractQueryParams","doc":"Module for extracting query parameters from a list of keywords.","ref":"ExtractQueryParams.html"},{"type":"function","title":"ExtractQueryParams.to_variables/1","doc":"Turns list of keywords to SQL statement variables, connected with an operator (defaults to \"AND\").","ref":"ExtractQueryParams.html#to_variables/1"},{"type":"function","title":"Examples - ExtractQueryParams.to_variables/1","doc":"iex> ExtractQueryParams.to_variables(foo: \"bar\")\n    {\"foo = ?\", [\"bar\"]}","ref":"ExtractQueryParams.html#to_variables/1-examples"},{"type":"function","title":"ExtractQueryParams.to_variables/2","doc":"","ref":"ExtractQueryParams.html#to_variables/2"},{"type":"function","title":"ExtractQueryParams.to_variables!/2","doc":"Turns list of keywords to SQL statement variables, connected with an operator (defaults to \"AND\").\nRaises an ArgumentError if the logical operator is not supported.","ref":"ExtractQueryParams.html#to_variables!/2"},{"type":"function","title":"Examples - ExtractQueryParams.to_variables!/2","doc":"iex(1)> ExtractQueryParams.to_variables!([foo: \"foo\", bar: \"bar\"], \"AND\")\n    {\"foo = ? AND bar = ?\", [\"foo\", \"bar\"]}\n\n    iex(2)> ExtractQueryParams.to_variables!([foo: \"foo\", bar: \"bar\"], \"UNSUPPORTED\")\n    ** (ArgumentError) logical operator \"UNSUPPORTED\" is not supported.","ref":"ExtractQueryParams.html#to_variables!/2-examples"},{"type":"extras","title":"ExtractQueryParams","doc":"# ExtractQueryParams\n\nConverts keyword list to query string with values extracted from the keyword list.","ref":"readme.html"},{"type":"extras","title":"Motivation - ExtractQueryParams","doc":"I was building a toy rest-api using plug-cowboy and wanted a way to turn query parameters such as `name: \"Bob, age: 15` into sql statements such as:\n\n```ex\nDepo.read(\"SELECT * FROM customers WHERE\"   \"name = ? AND age = ?\", \"Bob\", 15)\n```\n\nin a simple way","ref":"readme.html#motivation"},{"type":"extras","title":"Usage - ExtractQueryParams","doc":"```ex\nExtractQueryParams.to_variables(name: \"Bob\", age: 15)\n{\"name= ? AND age = ?\", [\"Bob\", 15]} #returns\n```\n\nThe default logical operator is AND but you can also specify which operator you want:\n\n```ex\nExtractQueryParams.to_variables([name: \"Bob\", age: 15], \"OR\")\n{\"name= ? OR age = ?\", [\"Bob\", 15]} #returns\n```","ref":"readme.html#usage"},{"type":"extras","title":"Installation - ExtractQueryParams","doc":"Add `extract_query_params` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:extract_query_params, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be found at [https://hexdocs.pm/extract_query_params](https://hexdocs.pm/extract_query_params).","ref":"readme.html#installation"}],"content_type":"text/markdown"}